# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')
fa = open(sys.argv[3], 'rt')
verbose = len(sys.argv) > 4 and sys.argv[4] == '-v'

n, k = [int(_) for _ in fi.readline().split()]
if 1 > n or n > 10**5:
	sys.exit('N out of range')
if 0 > k or k > 10**14:
	sys.exit('K out of range')
fo.write('{0} {1}\n'.format(n, k))

s = []
maxr = 0
for i in range(n):
	l, r = [int(_) for _ in fi.readline().split()]
	if 1 > l or l >= r or r > 10**9:
		sys.exit('Segment {0} endpoints our of range'.format(1 + i))
	fo.write('{0} {1}\n'.format(l, r))
	s.append((l, r))
	maxr = max(maxr, r)

s.sort()
overlap = False
for i in range(1, n):
	if s[i - 1][1] >= s[i][0]:
		overlap = True

fi.close()
fo.close()
fa.close()

if verbose:
	if k == 0:
		print('subtask 1')
	elif not overlap:
		print('subtask 2')
	elif n <= 500 and maxr <= 500:
		print('subtask 3')
	elif n <= 5000 and maxr <= 5000:
		print('subtask 4')
	elif n <= 10**4:
		print('subtask 5')
	else:
		print('subtask 6')
