# -- coding: utf8 --

import sys

n, k = [int(_) for _ in sys.stdin.readline().split()]

lr = []
for _ in range(n):
	lr.append([int(_) for _ in sys.stdin.readline().split()])


# vastuselõik peab ulatama vähemalt antud lõikude keskpunktide
# hulgas kõige vasakpoolsemast kõige parempoolsemani ja olema
# vähemalt pool kõige pikemast lõigust
segl, segr, minlen = 1_000_000_001, 0, 0
for ll, rr in lr:
	ulen = (rr - ll) // 2 # katmata osa max pikkus
	segl = min(segl, ll + ulen)
	segr = max(segr, rr - ulen)
	minlen = max(minlen, rr - ll - ulen)

# loeme [segl, segr] lõiguga võimalike tükelduskohtade arvu ja teeme
# sellest lõigust vasakult ja paremalt välja ulatuvate loendid
cnt = 0
lout, rout = [], []
for ll, rr in lr:
	if ll >= segl:
		if rr <= segr:
			# [ll, rr] on täielikult kaetud
			cnt += rr - ll - 1
		else:
			# [ll, rr] ulatub paremalt välja
			rout.append((rr, 1))
			cnt += (segr - (rr - segr)) - ll
	else:
		if rr <= segr:
			# [ll, rr] ulatub vasakult välja
			lout.append((ll, 1))
			cnt += rr - (segl + (segl - ll))
		else:
			# [ll, rr] ulatub mõlemalt poolt välja
			lout.append((ll, 1))
			rout.append((rr, 1))
			# see siin võib tulla negatiivne, kui [segl, segr] on
			# alla poole [l[i], r[i]] pikkusest; aga enne vastuse
			# väljastamist kasvatame [segl, segr]  pikemaks ja selle
			# käigus arvestame need "negatiivsed" tükelduskohad tagasi
			cnt += (segr - (rr - segr)) - (segl + (segl - ll)) + 1

# koondab võrdse esimese liikmega paarid kokku
def unique(v):
	if len(v) == 0:
		return v
	v.sort()
	n = 0
	for i in range(1, len(v)):
		if v[n][0] == v[i][0]:
			v[n] = (v[n][0], v[n][1] + v[i][1])
		else:
			n += 1
			v[n] = v[i]
	del v[n + 1 : ]

lnum, rnum = len(lout), len(rout)
unique(lout)
unique(rout)
rout.reverse()

while cnt < k or segr - segl < minlen:
	# üldiselt lisab iga väljaulatav lõik kattelõigu pikendamisel
	# 1 ühiku võrra 2 uut võimalikku tükelduskohta
	lcnt, rcnt = 2 * lnum, 2 * rnum
	# kui kaugele saame kattelõiku ühe hooga vasakule pikendada
	if len(lout) == 0:
		# kui vasakul enam väljaulatuvaid lõike pole, pole
		# mõtet ka kattelõiku sinnapoole pikendada
		lmax = 0
	elif lout[-1][0] == segl - 1:
		# kui mingid väljaulatuvad lõigud saavad 1 ühiku pärast läbi
		# lisavad need igaüks ainult 1 uue tükelduskoha
		lcnt -= lout[-1][1]
		lmax = 1
	else:
		# korraga saame edasi liikuda seni, kuni kõik väljaulatuvad
		# lõigud kestavad
		lmax = segl - lout[-1][0] - 1
	# kui kaugele saame kattelõiku ühe hooga paremale pikendada
	if len(rout) == 0:
		rmax = 0
	elif rout[-1][0] == segr + 1:
		rcnt -= rout[-1][1]
		rmax = 1
	else:
		rmax = rout[-1][0] - segr - 1
	# valime kattelõigu pikendamiseks ahnelt kasulikuma suuna
	if lcnt > rcnt:
		# kui palju peaks pikendama, et saada vajalik tükelduskohtade arv
		d = (k - cnt + lcnt - 1) // lcnt
		# kui palju peaks pikendma, et saada vajalik kattelõigu pikkus
		if d < minlen - (segr - segl):
			d = minlen - (segr - segl)
		# aga mitte üle maksimumi, milleni väljaulatuvate lõikude püsib
		if d > lmax:
			d = lmax
		cnt += d * lcnt
		segl -= d
		if lout[-1][0] == segl:
			# mõned väljaulatuvad lõigud said täielikut kaetud
			# võtame need nimekirjast maha
			lnum -= lout.pop()[1]
	else:
		d = (k - cnt + rcnt - 1) // rcnt
		if d < minlen - (segr - segl):
			d = minlen - (segr - segl)
		if d > rmax:
			d = rmax
		cnt += d * rcnt
		segr += d
		if rout[-1][0] == segr:
			rnum -= rout.pop()[1]

print(segr - segl)
