# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')
fa = open(sys.argv[3], 'rt')
verbose = len(sys.argv) > 4 and sys.argv[4] == '-v'

n, r = [int(_) for _ in fi.readline().split()]
if 1 > n or n > 2000:
	sys.exit('N out of range')
if 2 > r or r > 15:
	sys.exit('R out of range')
fo.write('{0} {1}\n'.format(n, r))

t = set()
#ml = 0
for i in range(n):
	s = fi.readline().strip()
	if 1 > len(s) or len(s) > 50:
		sys.exit('Length of S[{0}] out of range'.format(1 + i))
	if 'A' > min(s) or max(s) > chr(ord('A') + r - 1):
		sys.exit('Contents of S[{0}] out of range'.format(1 + i))
	fo.write('{0}\n'.format(s))
	t |= set(s)
	#ml = max(ml, len(s))

g = int(fa.readline())

fi.close()
fo.close()
fa.close()

if verbose:
	#print('max len {}'.format(ml))
	if len(t) < r:
		print('not all letters used')
	if g <= 3:
		print('subtask 1')
	elif g >= r - 3:
		print('subtask 2')
	else:
		print('subtask 3')
