# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')
fa = open(sys.argv[3], 'rt')
verbose = len(sys.argv) > 4 and sys.argv[4] == '-v'

n = int(fi.readline().strip())
if 1 > n or n > 2*10**5:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

maxab = 0
eqab = False
for i in range(n):
	a, b = [int(_) for _ in fi.readline().split()]
	if 1 > a or a > 10**9:
		sys.exit('A[{0}] out of range'.format(1 + i))
	if 1 > b or b > 10**9:
		sys.exit('B[{0}] out of range'.format(1 + i))
	fo.write('{0} {1}\n'.format(a, b))
	maxab = max(maxab, a, b)
	eqab = eqab or (a == b)

fi.close()
fo.close()
fa.close()

if verbose:
	if eqab:
		print("doubles exist")
	if n <= 20 and maxab <= 2*10**5:
		print('subtask 1')
	elif n <= 1000 and maxab <= 2*10**5:
		print('subtask 2')
	elif maxab <= 2*10**5:
		print('subtask 3')
	else:
		print('subtask 4')
